<?php

/**
 * @package plugin DoNotTrack
 * @copyright (C) 2010-2013 Michael Richey
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemDoNotTrack extends JPlugin {
    private $_DNT;
    private $_trackingACL=false;
    
    public function onAfterInitialise() {
        $this->_DNT = isset($_SERVER['HTTP_DNT'])?$_SERVER['HTTP_DNT']:0;
        if(
            JFactory::getApplication()->isAdmin() || // not necessary for /administrator
            JFactory::getDocument()->getType() != 'html' || // not necessary for non-html pages
            (
                !class_exists('ReflectionClass',false) || 
                !method_exists('ReflectionProperty','setAccessible')
            ) // Server doesn't support this extension - quit while we're ahead
        ) return true;
        
        $user = JFactory::getUser();
        $authLevels = $user->getAuthorisedViewLevels();
        $this->_trackingACL = $this->params->get('trackingACL',false);
        
        if($this->_trackingACL) {
            switch($this->_DNT) {
                case 1:
                    if(array_search($this->_trackingACL,$authLevels)) $this->_addViewLevel($user,$authLevels,true);
                    break;
                case 0:
                    if(!array_search($this->_trackingACL,$authLevels)) $this->_addViewLevel($user,$authLevels);
                    break;
            }
        }
        return true;
    }
    function _addViewLevel($user,$authLevels,$remove=false) {
        // this is kinda hacky - but Joomla gives no other method to add groups on-the-fly
        $JAccessReflection = new ReflectionClass('JUser');
        $_authLevels = $JAccessReflection->getProperty('_authLevels');
        $_authLevels->setAccessible(true);
        if(!$remove) {
            $authLevels[]=$this->_trackingACL;
        } else {
            unset($authLevels[array_search($this->_trackingACL,$authLevels)]);
        }
        $_authLevels->setValue($user,$authLevels);
    }
}